precision mediump float;

attribute vec3 aPosition;
uniform mat4 matrix;
uniform float progress;
varying vec3 pos;

void main() {
	pos = aPosition;
	vec4 p = vec4(aPosition, 1.0);
	if(progress <= 0.0){
		p.x += progress;
		p.x -= 0.5 * (cos(0.0) - cos(p.y));
		p.y *= sin((p.x + 1.05) * 3.1416 * 0.25);
	}else if(progress < 1.0){
		p.y *= sin(((p.x - 0.95) * (1.0 - progress) + 2.0) * 3.1416 * 0.25);
		p.x -= 0.5 * (cos(0.0) - cos(p.y)) * (1.0 - progress);
	}
	
	gl_Position = matrix * p;
}